#include <math.h>
#define EPS 3.0e-14
#define MAXIT 10

float gammln(float xx)
{
    double tmp, ser;

    tmp  = xx + 4.5;
    tmp -= (xx - 0.5) * log(tmp);

    ser = 1.000000000190015
        + (76.18009172947146     / xx)
        - (86.50532032941677     / (xx + 1.0))
        + (24.01409824083091     / (xx + 2.0))
        - (1.231739572450155     / (xx + 3.0))
        + (0.1208650973866179e-2 / (xx + 4.0))
        - (0.5395239384953e-5    / (xx + 5.0));

    return (log(2.5066282746310005 * ser) - tmp);
}
 

void gaulag(float x[], float w[], int n, float alf)
{
	float gammln(float xx);
	//void nrerror(char error_text[]);
	int i,its,j;
	float ai;
	double p1,p2,p3,pp,z,z1;

	for (i=1;i<=n;i++) {
		if (i == 1) {
			z=(1.0+alf)*(3.0+0.92*alf)/(1.0+2.4*n+1.8*alf);
		} else if (i == 2) {
			z += (15.0+6.25*alf)/(1.0+0.9*alf+2.5*n);
		} else {
			ai=i-2;
			z += ((1.0+2.55*ai)/(1.9*ai)+1.26*ai*alf/
				(1.0+3.5*ai))*(z-x[i-2])/(1.0+0.3*alf);
		}
		for (its=1;its<=MAXIT;its++) {
			p1=1.0;
			p2=0.0;
			for (j=1;j<=n;j++) {
				p3=p2;
				p2=p1;
				p1=((2*j-1+alf-z)*p2-(j-1+alf)*p3)/j;
			}
			pp=(n*p1-(n+alf)*p2)/z;
			z1=z;
			z=z1-p1/pp;
			if (fabs(z-z1) <= EPS) break;
		}
		//if (its > MAXIT) nrerror("too many iterations in gaulag");
		x[i]=z;
		w[i] = -exp(gammln(alf+n)-gammln((float)n))/(pp*n*p2);
	}
}
#undef EPS
#undef MAXIT
